#include <stdio.h>

#include "fl_ext_tree_browser_demo_ui.h"
#include "fl_ext_demo_ui.h"


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////


extern Fl_Ext_DemoUI *g_pUI;


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////


static char *get_name(void *pData)
{
  return "Fl_Ext_TreeBrowser";
}


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////


static void handle_free(void *pData)
{
  delete (Fl_Ext_TreeBrowser_DemoUI*)pData;
}


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////


static int handle_select(void *pData, int bState)
{
  Fl_Ext_TreeBrowser_DemoUI *pUI = (Fl_Ext_TreeBrowser_DemoUI*)pData;

  if(bState)
  {
    g_pUI->show_page(pUI->m_grpProperties);
    g_pUI->set_info_base("fl_ext_tree_browser");

    pUI->refresh_form();
  }
  else
  {
    g_pUI->hide_page(pUI->m_wndMain);
    g_pUI->set_info_base(NULL);
  }

  return 1; 
}


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////


void add_tree_browser(int nLevel)
{
  Fl_Ext_TreeItem *pTreeItem = new Fl_Ext_TreeItem;

  pTreeItem->m_nLevel = nLevel;
  pTreeItem->m_pData = new Fl_Ext_TreeBrowser_DemoUI;
  pTreeItem->GetName = get_name; 
  pTreeItem->GetGrey = NULL; 
  pTreeItem->HandleFree = handle_free;
  pTreeItem->HandleSelect = handle_select;
  pTreeItem->HandleInvoke = NULL;
  pTreeItem->HandleMenu = NULL;

  g_pUI->add_item(pTreeItem);
}


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////


