// generated by Fast Light User Interface Designer (fluid) version 1.0105

#include "fl_ext_date_chooser_demo_ui.h"
#include "fl_ext_date_chooser.h"
#include "mjd.h"
#include <stdio.h>

inline void Fl_Ext_DateChooser_DemoUI::cb_Select_i(Fl_Button*, void*) {
  double dDate = get_date();

if(fl_ext_date_chooser(&dDate)) set_date(dDate);
}
void Fl_Ext_DateChooser_DemoUI::cb_Select(Fl_Button* o, void* v) {
  ((Fl_Ext_DateChooser_DemoUI*)(o->parent()->parent()->user_data()))->cb_Select_i(o,v);
}

inline void Fl_Ext_DateChooser_DemoUI::cb_En_i(Fl_Button*, void*) {
  const char *french_months[12] = 
{
  "Janvier", 
  "Fvrier", 
  "Mars", 
  "Avril", 
  "Mai", 
  "Juin", 
  "Juillet", 
  "Aot", 
  "Septembre", 
  "Octobre", 
  "Novembre", 
  "Dcembre" 
};

const char *french_days[7] = { "D", "L", "M", "M", "J", "V", "S" };
const char *french_title = "Choissisez Date";
const char *french_ok = "OK";
const char *french_cancel = "Annuler";

double dDate = get_date();

fl_ext_date_text(french_title, french_months, french_days, french_ok, french_cancel);

if(fl_ext_date_chooser(&dDate)) set_date(dDate);

fl_ext_date_text(NULL, NULL, NULL, NULL, NULL);
}
void Fl_Ext_DateChooser_DemoUI::cb_En(Fl_Button* o, void* v) {
  ((Fl_Ext_DateChooser_DemoUI*)(o->parent()->parent()->user_data()))->cb_En_i(o,v);
}

Fl_Ext_DateChooser_DemoUI::Fl_Ext_DateChooser_DemoUI() {
  Fl_Double_Window* w;
  { Fl_Double_Window* o = m_wndMain = new Fl_Double_Window(339, 262);
    w = o;
    o->color((Fl_Color)3);
    o->labelcolor(FL_FOREGROUND_COLOR);
    o->user_data((void*)(this));
    { Fl_Group* o = m_grpProperties = new Fl_Group(0, 0, 296, 196);
      o->box(FL_FLAT_BOX);
      o->labeltype(FL_SHADOW_LABEL);
      o->labelfont(2);
      o->labelsize(48);
      o->labelcolor((Fl_Color)14);
      o->align(192|FL_ALIGN_INSIDE);
      { Fl_Box* o = new Fl_Box(5, 5, 161, 25, "fl_ext_date_chooser()");
        o->labelfont(1);
        o->labelcolor(FL_FOREGROUND_COLOR);
        o->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
      }
      { Fl_Button* o = new Fl_Button(188, 96, 100, 20, "Select Date...");
        o->callback((Fl_Callback*)cb_Select);
      }
      { Fl_Button* o = new Fl_Button(188, 120, 100, 20, "En Fran\347""ais...");
        o->callback((Fl_Callback*)cb_En);
      }
      m_texJulian = new Fl_Output(138, 146, 150, 20, "Modified Julian Date");
      m_texGregorian = new Fl_Output(138, 170, 150, 20, "Gregorian Date");
      o->end();
    }
    o->end();
    o->resizable(o);
  }
  set_date(DD_MIN);
}

Fl_Ext_DateChooser_DemoUI::~Fl_Ext_DateChooser_DemoUI() {
  delete m_wndMain;
}

void Fl_Ext_DateChooser_DemoUI::set_date(double dDate) {
  int y, m, d, h, mi;
double s;
char tex[64];

m_dDate = dDate;

if(m_dDate <= DD_MIN)
{
  sprintf(tex, "(invalid)");
}
else
{
  sprintf(tex, "%0.6f", m_dDate);
}
m_texJulian->value(tex);

if(m_dDate > DD_MIN)
{
  mjd_calc_gregorian(MJD_ROUND(m_dDate, 0), &y, &m, &d, &h, &mi, &s);
  sprintf(tex, "%.4d-%.2d-%.2d %.2d:%.2d:%.2d", y, m, d, h, mi, (int)s);
}
m_texGregorian->value(tex);
}

double Fl_Ext_DateChooser_DemoUI::get_date(void) {
  return m_dDate;
}
