/********************************************************************/
/********************************************************************/

/* fl_ext_date_chooser()
 *
 * This code released into the public domain by Don Zimmer
 * with permission from Baird Software, October 2004
 * provided as-is, use at your own risk
 *
 */

/********************************************************************/
/********************************************************************/


#ifndef FL_EXT_DATE_CHOOSER_H
#define FL_EXT_DATE_CHOOSER_H


#if defined(_LANGUAGE_C_PLUS_PLUS) || defined(__cplusplus)
extern "C" {
#endif

  
/********************************************************************/
/********************************************************************/


/* invalid date used to represent "now"
*/
#define DD_MIN -1e30


/********************************************************************/
/********************************************************************/


/* change text on dialog for other languages
*/
void fl_ext_date_text(
  const char *prompt, 
  const char *months[12], 
  const char *headings[7], 
  const char *ok, 
  const char *cancel);

/* change/limit date format
*/
void fl_ext_date_format(int am_pm, int lock);

/* choose a date
*/
int fl_ext_date_chooser(double *date);


/********************************************************************/
/********************************************************************/


/* callbacks (should really be moved into FLUID UI class)
*/
extern void dd_done(int rc);
extern void dd_change_year(int val);
extern void dd_spin_year(int val);
extern void dd_change_month(int val);
extern void dd_change_day(int val);
extern void dd_change_hour(int val);
extern void dd_change_minute(int val);
extern void dd_change_second(int val);
extern void dd_change_format(const char *val);
extern void dd_spin_time(int val);


/********************************************************************/
/********************************************************************/


#if defined(_LANGUAGE_C_PLUS_PLUS) || defined(__cplusplus)
}
#endif


#endif /* FL_EXT_DATE_CHOOSER_H */


/********************************************************************/
/********************************************************************/


