//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

// Fl_Ext_InertSlider
//
// This code released into the public domain by Don Zimmer
// with permission from Baird Software, October 2004
// provided as-is, use at your own risk

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////


#include "fl_ext_inert_slider.h"

#include <string.h>


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////


Fl_Ext_InertSlider::Fl_Ext_InertSlider(int x, int y, int w, int h, const char *l) : Fl_Value_Slider(x,y,w,h,l) 
{
  m_pSuffix = NULL;
}


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////


int Fl_Ext_InertSlider::handle(int event) 
{
  if(event == FL_PUSH || event == FL_DRAG) return 1;
  return Fl_Value_Slider::handle(event);
}


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////


int Fl_Ext_InertSlider::format(char* buffer) 
{
  int nChars = Fl_Value_Slider::format(buffer);

  if(m_pSuffix)
  {
    strcat(buffer, m_pSuffix);
    nChars += strlen(m_pSuffix);
  }

  return nChars;
}


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////


void Fl_Ext_InertSlider::Suffix(char *pSuffix)
{
  m_pSuffix = pSuffix;
}


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////


