/********************************************************************/
/********************************************************************/

/* fl_ext_page_setup()
 *
 * This code released into the public domain by Don Zimmer
 * with permission from Baird Software, October 2004
 * provided as-is, use at your own risk
 *
 */

/********************************************************************/
/********************************************************************/


#ifndef FL_EXT_PAGE_SETUP_H
#define FL_EXT_PAGE_SETUP_H


#if defined(_LANGUAGE_C_PLUS_PLUS) || defined(__cplusplus)
extern "C" {
#endif


/********************************************************************/
/********************************************************************/


#ifdef WIN32
  #include <windows.h>
  typedef struct {
    int dpi[2];         /* printer dpi */
    int eUnits;
    double size[2];
    double margin[4];

    HGLOBAL hDevMode;   /* DEVMODE struct */
    HGLOBAL hDevNames;  /* DEVNAMES struct */
    char queue[256];    /* print queue name, "" = use filename */
    char filename[256]; /* for postscript file */
  } PRINT_SPEC;
#else
  typedef struct {
    int dpi[2];
    int eUnits;
    double size[2];
    double margin[4];

    char queue[256];    /* print queue name, "" = use filename */
    char filename[256]; /* for postscript file */
  } PRINT_SPEC;
#endif


enum { PAGE_W, PAGE_H };

enum { PAGE_INCH, PAGE_CM };

enum { PAGE_LM, PAGE_TM, PAGE_RM, PAGE_BM };


#define INCH_TO_CM(i) ((i)*2.54)
#define CM_TO_INCH(c) ((c)*0.3937)


/********************************************************************/
/********************************************************************/


/* passing NULL gets the default setup
*/
PRINT_SPEC *fl_ext_page_setup(PRINT_SPEC *pSpec);


/********************************************************************/
/********************************************************************/


#if defined(_LANGUAGE_C_PLUS_PLUS) || defined(__cplusplus)
}
#endif


#endif /* FL_EXT_PAGE_SETUP_H */


/********************************************************************/
/********************************************************************/

