//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

// Fl_Ext_TreeBrowser
//
// This code released into the public domain by Don Zimmer
// with permission from Baird Software, October 2004
// provided as-is, use at your own risk

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////


#ifndef FL_EXT_TREE_BROWSER_H
#define FL_EXT_TREE_BROWSER_H


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////


#include <FL/Fl.H>
#include <FL/Fl_Browser_.H>


#include "fl_ext_tree_item.h"


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////


class Fl_Ext_TreeBrowser : public Fl_Browser_
{
public:
  Fl_Ext_TreeBrowser(int x, int y, int w, int h, const char *l=0);
  
  virtual ~Fl_Ext_TreeBrowser();

  // fltk overrides
  void *item_first() const;
  void *item_next(void *) const;
  void *item_prev(void *) const;
  int item_width(void *) const;
  int item_height(void *) const;
  void item_draw(void *,int,int,int,int) const;
  int handle(int event);

  // added API
  int Add(Fl_Ext_TreeItem *pItem, int bSelect=0);
  int Remove(Fl_Ext_TreeItem *pItem);
  int Prune(Fl_Ext_TreeItem *pItem);
  int InsertAfter(Fl_Ext_TreeItem *pPrev, Fl_Ext_TreeItem *pItem, int bSelect = 0);

  int Select(Fl_Ext_TreeItem *pItem);
  int Select(int nLine);
  int SelectLast(int nLevel);

  Fl_Ext_TreeItem *Selection(void) const;

  Fl_Ext_TreeItem *Find(int (*pFunc)(void *a, void *b), void *pArg);

  static int _s_DefaultFindFunc(void *a, void *b);

  // default do-nothing callback, user template
  static void _s_DefaultCallback(Fl_Widget *, void *);

private:
  int _Remove(Fl_Ext_TreeItem *pItem, int bFree); // return 1 if changed

  Fl_Ext_TreeItem *m_pFirst;
  Fl_Ext_TreeItem *m_pLast;
};


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////


#endif // FL_EXT_TREE_BROWSER_H


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////


