//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

// Fl_Ext_TreeItem
//
// This code released into the public domain by Don Zimmer
// with permission from Baird Software, October 2004
// provided as-is, use at your own risk

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////


#ifndef FL_EXT_TREE_ITEM_H
#define FL_EXT_TREE_ITEM_H


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////


class Fl_Ext_TreeItem
{
public:
  Fl_Ext_TreeItem();
  ~Fl_Ext_TreeItem();

  // user setable callbacks etc.
  char* (*GetName)(void *pData);
  int   (*GetGrey)(void *pData);
  void  (*HandleFree)(void *pData);
  int   (*HandleSelect)(void *pData, int bState);
  int   (*HandleInvoke)(void *pData);
  int   (*HandleMenu)(void *pData);
  void* m_pData;

  int IsOpen(void);
  int IsParent(void);

  Fl_Ext_TreeItem *GetParent(void);
  Fl_Ext_TreeItem *GetLastChild(void);

  int IsLastSibling();
  int IsFirstSibling();

  int SetBranchVisible(int bVisible);

public:
  int m_nLevel;
  char m_bVisible;
  char m_bSelected;

  Fl_Ext_TreeItem *m_pPrev;
  Fl_Ext_TreeItem *m_pNext;
};


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////


#endif // FL_EXT_TREE_ITEM_H


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////


